#include <iostream>
#include <vector>
using namespace std;

int main()
{
    int h, n;
    cin >> h >> n;

    vector<vector<int>> vodopad(h + 1, vector<int>(n + 1));
    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= n; j++)
            cin >> vodopad[i][j];

    vector<int> tezina(n + 1, 1);

    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= n; j++)
        {
            if (vodopad[i][j] == 0)
            {
                int pocetak = j, kraj, kolicina = 0;
                while (vodopad[i][j] == 0 && j <= n)
                {
                    kolicina += tezina[j];
                    tezina[j] = 0;
                    j++;
                }
                kraj = j - 1;
                if (pocetak >= 2 && kraj <= n - 1)
                {
                    tezina[pocetak - 1] += kolicina / 2;
                    tezina[kraj + 1] += kolicina / 2;
                    if (kolicina % 2 == 1)
                    {
                        if (i % 2 == 0)
                            tezina[kraj + 1]++;
                        else
                            tezina[pocetak - 1]++;
                    }
                }
                else if (pocetak < 2)
                    tezina[kraj + 1] += kolicina;
                else
                    tezina[pocetak - 1] += kolicina;
            }
        }

    for (int i = 1; i <= n; i++)
        cout << tezina[i] << " ";
    cout << endl;
}